#ifndef _configuration_h_
#define _configuration_h_


/* configuration.h ***************************************************

14-APR-94 DSA error log configuration details added.
27-APR-94 John Colville's liberal matching patch added.
27-APR-94 unique key attribute type details added.
*********************************************************************/


#define CONFIG1FILENAME	"bulkloadconfig1file"
#define CONFIG2FILENAME	"bulkloadconfig2file"


struct	autoInsertObjClsListNode {

	AttributeValue	autoInsertObjClsAttrV ;
	struct autoInsertObjClsListNode * nextAutoInsertObjClsListNodep ;
} ;

#define	NULLAUTOINSERTOBJCLSLIST ((struct autoInsertObjClsListNode *) NULL)

struct	autoInsertNode {

	AttributeType	autoInsertOnAttrT ;
	AttributeValue	autoInsertOnAttrV ;

	struct	autoInsertObjClsListNode * autoInsertObjClsListp ;

	struct  autoInsertNode * nextAutoInsertNodep ;
} ;

#define	NULLAUTOINSERTNODE	((struct autoInsertNode *) NULL)


struct	uniqueKeyNode {
	AttributeType	uniqueKeyAttrT ;
	struct  uniqueKeyNode * nextUniqueKeyNodep ;
} ;

#define NULLUNIQUEKEYNODE	((struct uniqueKeyNode *) NULL)





#define NUMCONFIGTITLETYPES	4

#define INVALIDTITLETYPE	-1
#define MINTITLETYPE		0
#define MALETITLEINDEX		0
#define MALETITLETYPE		0
#define FEMALETITLEINDEX	1
#define FEMALETITLETYPE		1
#define HUMANTITLEINDEX		2
#define HUMANTITLETYPE		2
#define NONHUMANTITLEINDEX	3
#define NONHUMANTITLETYPE	3
#define MAXTITLETYPE		3


#define NUMCONFIGERRORTYPES			10

/* Note: no add value when not master source since can not add if values already present */
#define ADDVALUETHATALREADYEXISTS		0
#define ADDATTRIBUTETHATALREADYEXISTS		1
#define ADDVALUEWHENNOTMASTERSOURCE		2
#define ADDATTRIBUTEWHENNOTMASTERSOURCE		3
#define DELETEVALUEWHENNOTMASTERSOURCE		4
#define DELETEATTRIBUTEWHENNOTMASTERSOURCE	5
#define DELETEVALUETHATDOESNOTEXIST		6
#define DELETEATTRIBUTETHATDOESNOTEXIST		7
#define CREATEENTRYWHENNOTCREATESOURCE		8
#define DELETEENTRYWHENNOTDELETESOURCE		9


struct bulkLoadConfigStruct {

#define BULKSOURCETOTALACCESSSNAME		"bulk"
	int bulkSourceTotalAccess ;

	int updatesToExistingEntries ;

	int updatesToExistingEntriesIfUnique ; /* Added by J.C. 20/04/94 */

	int ignoreCloseNameMatches ;
	
	int configErrorProcReq[ NUMCONFIGERRORTYPES ] ;

#define CONFIGMAXNUMTITLETOKENS	10
	char *	titleTokenscp[ NUMCONFIGTITLETYPES ] [ CONFIGMAXNUMTITLETOKENS ] ;
	int	lastUsedTitlesToken[ NUMCONFIGTITLETYPES ] ;

#define CONFIGNUMPERIODBEFOREDELTOKENS 	100
	AttributeType	checkAttrTypeForDeleteEntry ;
	AttributeValue	periodBeforeDeletionAttrV[ CONFIGNUMPERIODBEFOREDELTOKENS ] ;
#define CONFIGNOLIMITPERIODBEFOREDEL	-1
	int		periodBeforeDeletionForAttrV[ CONFIGNUMPERIODBEFOREDELTOKENS ] ;
	int		lastUsedPeriodBeforeDeleteToken ;


	struct	autoInsertNode * autoInsertNodep ;	
	
	int	allSourcesAreCreateSources ;
	
	int	autoAddEntryToAddAttrIfExists ;

#define CONFIGHIGHESTDATASRCLEVEL	1
#define CONFIGLOWESTDATASRCLEVEL	9
	int	highestDataSourceSearchLevel ;
	
	int	noMasterSpecifiedSoAllSourcesAreMasters ;

#define CONFIGNUMALLSRCMASTERS		50
	AttributeType	allSourcesAreMastersForAttrT[ CONFIGNUMALLSRCMASTERS ] ;
	int	lastUsedAttrTIndex ;

	int	valueClearDownPermittedOnFirstMasterUpdate ;

#define STARINITSTARSPACESURNAMESTAR		1
#define STARINITSTARSURNAMESTAR			2
#define STARSURNAMESPACEINITSTAR		3
	int	commonNameSearchFormat ;

	int	replaceFullStopCommonNameDelimsWithSpaces ;

	int	displayConfigAtStart ;

	int	disableBulkAttributeUsage ;

#define MAXDSAERRLOGTAILNBYTES			3072
	char *	dsaErrorLogFileNamecp ;
	long	dsaErrorLogTailNBytes ;

	struct  uniqueKeyNode * uniqueKeyNodep ;
} ;


/*
 * Bulk Management...
 */

struct	checkDNAttrTNode {
	AttributeType	checkDNAttrT ;
	struct	checkDNAttrTNode * nextCheckDNAttrTNode ;
} ;

#define NULLCHKDNNODE		((struct checkDNAttrTNode*)NULL )


struct managementConfigStruct {

	char *	defaultDNcp ;

	int	returnToMenu ;

	char *	sourceReportSubTreeParentDNcp ;
	DN	sourceReportSubTreeParentDN ;
	int	sourceReportLevels ;
	char *	sourceReportFileNamecp ;


	char *	expiredEntriesSubTreeParentDNcp ;
	DN	expiredEntriesSubTreeParentDN ;
	char *	expiredEntriesLogFileNamecp ;
	char *	expiredEntriesUTCtimecp ;

	char *	dumpSubtreeSubTreeParentDNcp ;
	DN	dumpSubtreeSubTreeParentDN ;
	char *	dumpSubtreeFileNamecp ;

	char *	addValueToSubTreeParentDNcp ;
	DN	addValueToSubTreeParentDN ;
	int	addValueToJustLeafNodes ;
	AttributeType	addValueToSubTreeAt ;
	AttributeValue	addValueToSubTreeAv ;
	
	char *	resetValidChkAtSubTreeParentDNcp ;
	DN	resetValidChkAtSubTreeParentDN ;
	char *	resetValidChkAtLogFileNamecp ;
	char *	resetValidChkAtUTCtimecp ;

	char *	sourceValidationInputFileNamecp ;

	char *	checkValidChkAtSubTreeParentDNcp ;
	DN	checkValidChkAtSubTreeParentDN ;
	char *	checkValidChkAtLogFileNamecp ;
	char *	checkValidChkAtUTCtimecp ;

	char *	masterUpAtToNonMasterSubTreeParentDNcp ;
	DN	masterUpAtToNonMasterSubTreeParentDN ;
	char *	masterUpAtToNonMasterLogFileNamecp ;
	char 	masterUpAtToNonMasterMode ; /* 'e' to exchange or 'r' to remove the "masterUpdatedAttrType"s */

	char *	checkDNSubTreeParentDNcp ;
	DN	checkDNSubTreeParentDN ;
	char *	checkDNLogFileNamecp ;
	struct	checkDNAttrTNode * checkDNAttrTs ; /* Initially specified in "bulkloadtailor" file */

	char *	roleOccXrefSubTreeParentDNcp ;
	DN	roleOccXrefSubTreeParentDN ;
	char *	roleOccXrefLogFileNamecp ;
} ;

#endif _configuration_h_

